<?php
/**
* Events Tab Class for handling the CB Tab API - Version 0.1 Beta 2
* @package Community Builder
* @author Jeffrey Hill - Derived from Joomla Joe's Blog Tab and Eric Lamette/Dave McDonnell/Geraint Edwards Events Component for Joomla! 1.2.1
*/

class getEventsTab extends cbTabHandler {
	function getEventsTab() {
		$this->cbTabHandler();
	}
	
	function _eventsIncludes()  {
    global $mosConfig_absolute_path, $mosConfig_lang;
        include_once($mosConfig_absolute_path."/administrator/components/com_events/lib/config.php");
		include_once($mosConfig_absolute_path."/components/com_events/events.html.php");
		include_once($mosConfig_absolute_path."/components/com_events/events.class.php");

        if (!defined( '_CAL_LANG_INCLUDED' )) {
            if (file_exists($mosConfig_absolute_path."/components/com_events/language/".$mosConfig_lang.".php") ) {
                include_once($mosConfig_absolute_path."/components/com_events/language/".$mosConfig_lang.".php");
            } else {
                include_once($mosConfig_absolute_path."/components/com_events/language/english.php");
            }
        }
    return true;
    }

	function getDisplayTab($tab,$user,$ui) {
		global $database, $option, $mosConfig_lang, $gid;
		$this->_eventsIncludes();
        // Event list ordering toggles
		$pagingParams = $this->_getPaging(array(),array("events_"));
		switch ($pagingParams["events_sortby"]) {
			case "title":
				$order = "a.title ASC";
				break;
			case "location":
				$order = "a.adresse_info ASC";
				break;
			case "date":
				$order = "a.publish_up ASC";
				break;
			case "hits":
                $order = "a.hits DESC";
                break;
			case "category":
                $order = "a.catid ASC";
                break;
			default:
				$order = "a.publish_up ASC";
				break;
		}
		// Set parameters
		$params       =   $this->params;
		$showcategory =   getLangDefinition($params->get('showCategory', '1'));
		$showlocation =   getLangDefinition($params->get('showLocation', '1'));
		$showhits     =   getLangDefinition($params->get('showHits', '1'));
		$datedisplay  =   getLangDefinition($params->get('dateDisplay', '0'));
		$pagingenabled  = getLangDefinition($params->get('pagingEnabled', '1'));
		$eventsnumber    = getLangDefinition($params->get('eventsNumber', '20'));
        $today = strftime( "%Y-%m-%d" );
        $return = "";
        //Query for event count
        $query = "SELECT COUNT(*)"
		. "\n FROM #__events AS a, #__categories as c"
		. "\n WHERE a.created_by=". $user->id .""
        . "\n AND a.catid = c.id"
		. "\n AND a.publish_down >\"$today 00:00:00\""
		. "\n AND a.state = 1"
        . "\n AND a.access <= $gid"
        ;
        $database->setQuery( $query );
		$total = $database->loadResult();
		if (!is_numeric($total)) $total = 0;
		if (!$total>0) {
			return $return;
		}
        if ($pagingParams["events_limitstart"] === null) $pagingParams["events_limitstart"] = "0";
        if ($eventsnumber > $total) $pagingParams["events_limitstart"] = "0";
		if ($tab->description != null)
        {
            $return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
        }
        // Query for a user's events
        $query = "SELECT a.*, c.name"
		. "\n FROM #__events AS a, #__categories as c"
		. "\n WHERE a.created_by=". $user->id .""
        . "\n AND a.catid = c.id"
		. "\n AND a.publish_down >\"$today 00:00:00\""
		. "\n AND a.state = 1"
        . "\n AND a.access <= $gid"
		. "\n ORDER BY ".$order
		. "\n LIMIT ".($pagingParams["events_limitstart"] ? $pagingParams["events_limitstart"] : "0").",".$eventsnumber;
		;
		$database->setQuery( $query );
		//print $database->getQuery();
		$items = $database->loadObjectList();
		
		// Output table header
		$return .= "<table cellpadding=\"2\" cellspacing=\"0\" border=\"0\" width=\"100%\">";
		$return .=    "<tr class=\"sectiontableheader\">";
		$return .=        ($showcategory) ? "<th>".$this->_writeSortByLink($pagingParams,"events_","category",'Category')."</th>" : "";
		$return .=        "<th>".$this->_writeSortByLink($pagingParams,"events_","title",'Event')."</th>";
		$return .=        ($showlocation) ? "<th>".$this->_writeSortByLink($pagingParams,"events_","location",'Location')."</th>" : "";
		$return .=        "<th>".$this->_writeSortByLink($pagingParams,"events_","date",'Date', true)."</th>";
		$return .=        ($showhits) ? "<th>".$this->_writeSortByLink($pagingParams,"events_","hits",'Hits')."</th>" : "";
		$return .=    "</tr>";
		
		// List out events
		$i = 1;
		foreach($items AS $item) {
			$i = ($i==1) ? 2 : 1;
			$event_up = new mosEventDate( $item->publish_up );
			$event_down = new mosEventDate( $item->publish_down );
            $eventDate = "";
							
			if ( $item->reccurtype == 1 ) {
				if ( $item->reccurday == 1 ) { $eventDate = _CAL_LANG_MONDAY; }
				if ( $item->reccurday == 2 ) { $eventDate = _CAL_LANG_TUESDAY; }
				if ( $item->reccurday == 3 ) { $eventDate = _CAL_LANG_WEDNESDAY; }
				if ( $item->reccurday == 4 ) { $eventDate = _CAL_LANG_THURSDAY; }
				if ( $item->reccurday == 5 ) { $eventDate = _CAL_LANG_FRIDAY; }
				if ( $item->reccurday == 6 ) { $eventDate = _CAL_LANG_SATURDAY; }
				if ( $item->reccurday == 7 ) { $eventDate = _CAL_LANG_SUNDAY; }
                $eventDate .= "&nbsp;("._CAL_LANG_EACHWEEK.")";
                // } else {
				//echo "(Weekly event)";
				} 
			else {
                $eventDate = mosEventsHTML::getDateFormat($event_up->year,$event_up->month,$event_up->day,$datedisplay);
                }
			$return .= "<tr class=\"sectiontableentry$i\">";
			if ( $showcategory == 1 ) {
                $return .= "<td><a href='index.php?option=com_events&task=view_cat&catid=".$item->catid."'>".$item->name."</a></td>\n";
                }
            $return .= "<td><a href=\"".sefReltoAbs("index.php?option=com_events&amp;task=view_detail&amp;agid=$item->id")."\">".$item->title."</a></td>\n";
            if ($showlocation == 1) {
                $return .= "<td>".$item->adresse_info."</td>";
              }
            $return .= "<td>".$eventDate."<br/>".$event_up->get12hrTime();
			if ( $event_up->get12hrTime() !== $event_down->get12hrTime() ) {
			$return .= " - ".$event_down->get12hrTime()."</td>\n";
				} else {
			$return .= "</td>\n";			
			}
            if ( $showhits == 1 ) {
                $return .= "<td>".$item->hits."</td>\n";
                }
            $return .="</tr>\n";
		    }
	$return .= "</table>\n";
	if ($pagingenabled == 1 && ($eventsnumber < $total)) {
        $return .= "<div style='width:95%;text-align:center;'>"
        .$this->_writePaging($pagingParams,"events_",$eventsnumber,$total)
        ."</div>";
    }
	return $return;
}  //end function getDisplayTab


}	// end class getEventsTab

?>
